diff --git a/gcc/m2/gm2-compiler/P2SymBuild.mod b/gcc/m2/gm2-compiler/P2SymBuild.mod
index 2196b584eb5..d51fd1c931a 100644
--- a/gcc/m2/gm2-compiler/P2SymBuild.mod
+++ b/gcc/m2/gm2-compiler/P2SymBuild.mod
@@ -1897,66 +1891,97 @@ BEGIN
          THEN
             (* Different parameter types.  *)
             ParameterError ('declaration in the %s differs from the %s, {%%2N} parameter is inconsistant, %s',
-                            'the parameter {%3Ea} was declared with a different type',  (* '{%3EHa}'.  *)
+                            'the parameter {%3EHa} was declared with a different type',
                             'the parameter {%3EVa} was declared with a different type',
-                            pi, ParamTotal+i, ProcSym, ProcTok, GetParam (ProcSym, ParamTotal+i), TypeTok)
+                            ParamTotal+i, ProcSym, curkind, prevkind)
          END
       END ;
-      INC(i) ;
-      DEC(pi)
-   END ;
-   PopN(NoOfIds+1) ;   (* +1 for the Var/Nul.  *)
-   PushT(ParamTotal+NoOfIds) ;
-   Assert(IsProcedure(OperandT(2)))
+      INC (i) ;
+      DEC (pi)
+   END
 END CheckFormalParameterSection ;
 
 
 (*
-   ParameterError - create two error strings chained together.  Both error strings
-                    commence with FmdHeader:
-                    1.  FmtHeader DefinedDesc ParamNo Param.
-                    2.  FmdHeader CurrentDesc ParamNo OperandT(ParamPtr).
-                    The FmtHeader will have a location description for the
-                    defined location and current location inserted by processing %s
-                    prior to passing the completed string to MetaError.
+   RemoveFPParameters - remove the FPSection parameters from the stack and
+                        increment the param total with the NoOfIds.
 
-                    Currently the location of the first error is fixed to the
-                    location of ProcSym.
+                        The Stack:
+
+                               Entry                 Exit
+
+                        Ptr ->
+                               +------------+
+                               | ParamTotal |
+                               |------------|
+                               | TypeSym    |
+                               |------------|
+                               | Array/Nul  |
+                               |------------|
+                               | NoOfIds    |
+                               |------------|
+                               | Id 1       |
+                               |------------|
+                               .            .
+                               .            .
+                               .            .
+                               |------------|
+                               | Id n       |                       <- Ptr
+                               |------------|        +------------+
+                               | Var / Nul  |        | ParamTotal |
+                               |------------|        |------------|
+                               | ProcSym    |        | ProcSym    |
+                               |------------|        |------------|
+*)
+
+PROCEDURE RemoveFPParameters ;
+VAR
+   ParamTotal,
+   Array,
+   TypeSym,
+   NoOfIds,
+   ProcSym   : CARDINAL ;
+BEGIN
+   PopT (ParamTotal) ;
+   PopT (TypeSym) ;
+   PopT (Array) ;
+   Assert ((Array=ArrayTok) OR (Array=NulTok)) ;
+   PopT (NoOfIds) ;
+   ProcSym := OperandT (NoOfIds+2) ;
+   Assert (IsProcedure (ProcSym)) ;
+   PopN (NoOfIds+1) ;   (* +1 for the Var/Nul.  *)
+   PushT (ParamTotal + NoOfIds) ;
+   Annotate ("%1d||running total of no. of parameters") ;
+   Assert (IsProcedure (OperandT (2)))
+END RemoveFPParameters ;
+
+
+(*
+   ParameterError - create two error strings chained together.
 *)
 
-PROCEDURE ParameterError (FmtHeader, DefinedDesc, CurrentDesc: ARRAY OF CHAR;
-                          ParamPtr, ParamNo, ProcSym, ProcTok, Param, TypeTok: CARDINAL) ;
+PROCEDURE ParameterError (FmtHeader, PrevDesc, CurDesc: ARRAY OF CHAR;
+                          ParamNo, ProcSym: CARDINAL;
+                          curkind, prevkind: ProcedureKind) ;
 VAR
-(*   parm, *)
-   Err       : CARDINAL ;
+   PrevParam,
+   CurParam   : CARDINAL ;
    CurStr,
-   DefStr,
+   PrevStr,
    Msg,
-   SrcProcSym,
-   SrcCurDecl: String ;
-BEGIN
-   SrcProcSym := GetSourceDesc (ProcSym) ;
-   SrcCurDecl := GetCurSrcDesc (ProcSym, ProcTok) ;
-   DefStr := InitString (DefinedDesc) ;
-   CurStr := InitString (CurrentDesc) ;
-   Msg := Sprintf3 (Mark (InitString (FmtHeader)), SrcProcSym, SrcCurDecl, DefStr) ;
-   MetaErrorStringT3 (GetDeclared (ProcSym), Msg, ProcSym, ParamNo, Param) ;
-(*
-   It could be improved by using the '{%3EHa}' specifier in the DefinedDesc (see
-   CheckFormalParameterSection) but this requires that the parameter declarations
-   for the definition and forward procedures are saved.  Currently they are only
-   checked against the proper procedure declaration.
-
-   WarnStringAt (InitString ('testing ProcSym decl'), GetDeclared (ProcSym)) ;
-   parm := GetParam (ProcSym, ParamNo) ;
-   WarnStringAt (InitString ('testing param ProcSym GetVarDeclTok'), GetVarDeclTok (parm)) ;
-   WarnStringAt (InitString ('testing param ProcSym GetVarDeclTypeTok'), GetVarDeclTypeTok (parm)) ;
-   WarnStringAt (InitString ('testing param ProcSym GetVarDeclFullTok'), GetVarDeclFullTok (parm)) ;
-   WarnStringAt (InitString ('testing cur pos'), MakeVirtual2Tok (OperandTok (ParamPtr), TypeTok)) ;
-*)
-   Err := MakeError (MakeVirtual2Tok (OperandTok (ParamPtr), TypeTok), OperandT (ParamPtr)) ;
-   Msg := Sprintf3 (Mark (InitString (FmtHeader)), SrcProcSym, SrcCurDecl, CurStr) ;
-   MetaErrorString3 (Msg, ProcSym, ParamNo, Err)
+   CurKindStr,
+   PrevKindStr: String ;
+BEGIN
+   CurParam := GetNthParam (ProcSym, curkind, ParamNo) ;
+   CurKindStr := GetProcedureKindDesc (curkind) ;
+   PrevKindStr := GetProcedureKindDesc (prevkind) ;
+   PrevParam := GetNthParam (ProcSym, prevkind, ParamNo) ;
+   PrevStr := InitString (PrevDesc) ;
+   CurStr := InitString (CurDesc) ;
+   Msg := Sprintf3 (Mark (InitString (FmtHeader)), CurKindStr, PrevKindStr, PrevStr) ;
+   MetaErrorString3 (Msg, ProcSym, ParamNo, PrevParam) ;
+   Msg := Sprintf3 (Mark (InitString (FmtHeader)), CurKindStr, PrevKindStr, CurStr) ;
+   MetaErrorString3 (Msg, ProcSym, ParamNo, CurParam)
 END ParameterError ;
 
 
@@ -1976,7 +2001,8 @@ END ParameterError ;
 
 PROCEDURE StartBuildFormalParameters ;
 BEGIN
-   PushT(0)
+   PushT (0) ;
+   Annotate ("%1d||running total of no. of parameters")
 END StartBuildFormalParameters ;
 
 
@@ -1986,29 +2012,30 @@ END StartBuildFormalParameters ;
                        NoOfPar is the current number of parameters.
 *)
 
-PROCEDURE ParameterMismatch (tok: CARDINAL; ProcSym: CARDINAL; NoOfPar: CARDINAL) ;
+PROCEDURE ParameterMismatch (tok: CARDINAL; ProcSym: CARDINAL;
+                             NoOfPar: CARDINAL; prevkind, curkind: ProcedureKind) ;
 VAR
    MsgCurrent,
-   MsgProcSym,
-   SrcProcSym,
-   SrcCurDecl,
-   CompProcSym,
-   CompCurrent: String ;
-BEGIN
-   SrcProcSym := GetSourceDesc (ProcSym) ;
-   SrcCurDecl := GetCurSrcDesc (ProcSym, tok) ;
-   CompProcSym := GetComparison (NoOfParam (ProcSym), NoOfPar) ;
-   CompCurrent := GetComparison (NoOfPar, NoOfParam (ProcSym)) ;
+   MsgPrev,
+   CompCur,
+   CompPrev,
+   CurDesc,
+   PrevDesc  : String ;
+BEGIN
+   CurDesc := GetProcedureKindDesc (curkind) ;
+   PrevDesc := GetProcedureKindDesc (prevkind) ;
+   CompPrev := GetComparison (NoOfParam (ProcSym, prevkind), NoOfPar) ;
+   CompCur := GetComparison (NoOfPar, NoOfParam (ProcSym, prevkind)) ;
    MsgCurrent := Sprintf3 (Mark (InitString ('the %s for {%%1ad} has %s parameters than the %s')),
-                           SrcCurDecl, CompCurrent, SrcProcSym) ;
-   MsgProcSym := Sprintf3 (Mark (InitString ('the %s for {%%1ad} has %s parameters than the %s')),
-                           SrcProcSym, CompProcSym, SrcCurDecl) ;
-   MetaErrorStringT1 (GetDeclared (ProcSym), MsgProcSym, ProcSym) ;
+                           CurDesc, CompCur, PrevDesc) ;
+   MsgPrev := Sprintf3 (Mark (InitString ('the %s for {%%1ad} has %s parameters than the %s')),
+                        PrevDesc, CompPrev, CurDesc) ;
+   MetaErrorStringT1 (GetProcedureDeclaredTok (ProcSym, prevkind), MsgPrev, ProcSym) ;
    MetaErrorStringT1 (tok, MsgCurrent, ProcSym) ;
-   SrcProcSym := KillString (SrcProcSym) ;
-   SrcCurDecl := KillString (SrcCurDecl) ;
-   CompProcSym := KillString (CompProcSym) ;
-   CompCurrent := KillString (CompCurrent)
+   CurDesc := KillString (CurDesc) ;
+   PrevDesc := KillString (PrevDesc) ;
+   CompCur := KillString (CompCur) ;
+   CompPrev := KillString (CompPrev)
 END ParameterMismatch ;
 
 
@@ -2030,18 +2057,27 @@ END ParameterMismatch ;
 
 PROCEDURE EndBuildFormalParameters ;
 VAR
+   kind,
+   curkind: ProcedureKind ;
    tok    : CARDINAL ;
    NoOfPar: CARDINAL ;
    ProcSym: CARDINAL ;
 BEGIN
    PopT (NoOfPar) ;
    PopTtok (ProcSym, tok) ;
-   PushT (ProcSym) ;
+   PushTtok (ProcSym, tok) ;
+   Annotate ("%1s(%1d)||procedure start symbol") ;
    Assert (IsProcedure (ProcSym)) ;
-   IF NoOfParam (ProcSym) # NoOfPar
-   THEN
-      ParameterMismatch (tok, ProcSym, NoOfPar)
+   curkind := GetProcedureKind (ProcSym, tok) ;
+   FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+      IF GetProcedureParametersDefined (ProcSym, kind) AND
+         (curkind # kind) AND (NoOfParam (ProcSym, kind) # NoOfPar)
+      THEN
+         ParameterMismatch (tok, ProcSym, NoOfPar, kind, curkind)
+      END
    END ;
+   (* All parameter seen so set procedure defined.  *)
+   PutProcedureParametersDefined (ProcSym, curkind) ;
    Assert (IsProcedure (OperandT (1)))
 END EndBuildFormalParameters ;
 
@@ -2065,103 +2101,49 @@ BEGIN
 END GetComparison ;
 
 
-(*
-   GetSourceDesc - return a description of where ProcSym was declared.
-*)
-
-PROCEDURE GetSourceDesc (ProcSym: CARDINAL) : String ;
-BEGIN
-   IF AreParametersDefinedInDefinition (ProcSym)
-   THEN
-      RETURN InitString ('definition module')
-   ELSIF GetParametersDefinedByForward (ProcSym)
-   THEN
-      RETURN InitString ('forward declaration')
-   ELSIF GetParametersDefinedByProper (ProcSym)
-   THEN
-      RETURN InitString ('proper declaration')
-   END ;
-   RETURN InitString ('')
-END GetSourceDesc ;
-
-
-(*
-   GetCurSrcDesc - return a description of where ProcSym was declared.
-*)
-
-PROCEDURE GetCurSrcDesc (ProcSym: CARDINAL; tok: CARDINAL) : String ;
-BEGIN
-   IF GetProcedureDeclaredDefinition (ProcSym) = tok
-   THEN
-      RETURN InitString ('definition module')
-   ELSIF GetProcedureDeclaredForward (ProcSym) = tok
-   THEN
-      RETURN InitString ('forward declaration')
-   ELSIF GetProcedureDeclaredProper (ProcSym) = tok
-   THEN
-      RETURN InitString ('proper declaration')
-   END ;
-   RETURN InitString ('')
-END GetCurSrcDesc ;
-
-
-(*
-   GetDeclared -
-*)
-
-PROCEDURE GetDeclared (sym: CARDINAL) : CARDINAL ;
-BEGIN
-   IF IsProcedure (sym)
-   THEN
-      IF AreParametersDefinedInDefinition (sym)
-      THEN
-         RETURN GetProcedureDeclaredDefinition (sym)
-      ELSIF GetParametersDefinedByProper (sym)
-      THEN
-         RETURN GetProcedureDeclaredProper (sym)
-      ELSIF GetParametersDefinedByForward (sym)
-      THEN
-         RETURN GetProcedureDeclaredForward (sym)
-      END
-   END ;
-   RETURN GetDeclaredMod (sym)
-END GetDeclared ;
-
-
 (*
    ReturnTypeMismatch - generate two errors showing the return type mismatches between
                         ProcSym and ReturnType at procedure location tok.
 *)
 
-PROCEDURE ReturnTypeMismatch (tok: CARDINAL; ProcSym, ReturnType: CARDINAL) ;
+PROCEDURE ReturnTypeMismatch (curtok: CARDINAL; ProcSym, CurRetType: CARDINAL;
+                              curtypetok: CARDINAL;
+                              curkind, prevkind: ProcedureKind;
+                              PrevRetType: CARDINAL) ;
 VAR
-   SrcProcSym,
-   SrcCurDecl,
+   prevtok   : CARDINAL ;
+   CurDesc,
+   PrevDesc,
    MsgCurrent,
-   MsgProcSym: String ;
+   MsgPrev   : String ;
 BEGIN
-   SrcProcSym := GetSourceDesc (ProcSym) ;
-   SrcCurDecl := GetCurSrcDesc (ProcSym, tok) ;
-   IF ReturnType = NulSym
+   CurDesc := GetProcedureKindDesc (curkind) ;
+   PrevDesc := GetProcedureKindDesc (prevkind) ;
+   prevtok := GetProcedureDeclaredTok (ProcSym, prevkind) ;
+   IF CurRetType = NulSym
    THEN
       MsgCurrent := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
-                              SrcCurDecl, SrcProcSym) ;
-      MsgProcSym := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
-                              SrcCurDecl, SrcProcSym)
-   ELSIF GetType (ProcSym) = NulSym
+                              CurDesc, PrevDesc) ;
+      MsgPrev := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
+                              CurDesc, PrevDesc) ;
+      prevtok := GetReturnTypeTok (ProcSym, prevkind)
+   ELSIF PrevRetType = NulSym
    THEN
       MsgCurrent := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
-                              SrcProcSym, SrcCurDecl) ;
-      MsgProcSym := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
-                              SrcProcSym, SrcCurDecl)
+                              PrevDesc, CurDesc) ;
+      MsgPrev := Sprintf2 (Mark (InitString ('there is no return type for {%%1ad} specified in the %s whereas a return type is specified in the %s')),
+                              PrevDesc, CurDesc) ;
+      curtok := curtypetok
    ELSE
       MsgCurrent := Sprintf2 (Mark (InitString ('the return type for {%%1ad} specified in the %s differs in the %s')),
-                              SrcCurDecl, SrcProcSym) ;
-      MsgProcSym := Sprintf2 (Mark (InitString ('the return type for {%%1ad} specified in the %s differs in the %s')),
-                              SrcCurDecl, SrcProcSym)
+                              CurDesc, PrevDesc) ;
+      MsgPrev := Sprintf2 (Mark (InitString ('the return type for {%%1ad} specified in the %s differs in the %s')),
+                              CurDesc, PrevDesc) ;
+      curtok := curtypetok ;
+      prevtok := GetReturnTypeTok (ProcSym, prevkind)
    END ;
-   MetaErrorStringT1 (GetDeclared (ProcSym), MsgProcSym, ProcSym) ;
-   MetaErrorStringT1 (tok, MsgCurrent, ProcSym)
+   MetaErrorStringT1 (curtok, MsgCurrent, ProcSym) ;
+   MetaErrorStringT1 (prevtok, MsgPrev, ProcSym)
 END ReturnTypeMismatch ;
 
 
@@ -2183,26 +2165,17 @@ END ReturnTypeMismatch ;
 
 PROCEDURE BuildFunction ;
 VAR
-   tok        : CARDINAL ;
-   PrevRetType,
-   RetType,
-   ProcSym    : CARDINAL ;
+   tok    : CARDINAL ;
+   ProcSym,
+   typetok: CARDINAL ;
+   RetType: CARDINAL ;
 BEGIN
-   PopT (RetType) ;
+   PopTtok (RetType, typetok) ;
    PopTtok (ProcSym, tok) ;
-   IF IsProcedure (ProcSym)
-   THEN
-      IF AreProcedureParametersDefined (ProcSym)
-      THEN
-         PrevRetType := GetType (ProcSym) ;
-         IF PrevRetType # RetType
-         THEN
-            ReturnTypeMismatch (tok, ProcSym, RetType)
-         END
-      END
-   END ;
-   PutFunction (ProcSym, RetType) ;
-   PushTtok (ProcSym, tok)
+   PushTtok (ProcSym, tok) ;
+   PutFunction (typetok, ProcSym, GetProcedureKind (ProcSym, tok), RetType) ;
+   CheckOptFunction (tok, ProcSym, GetProcedureKind (ProcSym, tok), FALSE) ;
+   CheckProcedureReturn  (RetType, typetok)
 END BuildFunction ;
 
 
@@ -2225,31 +2198,70 @@ END BuildFunction ;
 
 PROCEDURE BuildOptFunction ;
 VAR
-   TypeSym,
+   typetok,
+   tok     : CARDINAL ;
+   RetType,
    ProcSym : CARDINAL ;
 BEGIN
-   PopT(TypeSym) ;
-   PopT(ProcSym) ;
-   PutOptFunction(ProcSym, TypeSym) ;
+   PopTtok (RetType, typetok) ;
+   PopTtok (ProcSym, tok) ;
+   PutOptFunction (typetok, ProcSym, GetProcedureKind (ProcSym, tok), RetType) ;
+   CheckOptFunction (tok, ProcSym, GetProcedureKind (ProcSym, tok), TRUE) ;
+   PushTtok (ProcSym, tok)
+END BuildOptFunction ;
+
+
 (*
-   WriteString('Procedure ') ; WriteKey(GetSymName(ProcSym)) ;
-   WriteString(' has a return argument ') ;
-   WriteKey(GetSymName(TypeSym)) ;
-   WriteString(' checking ') ; WriteKey(GetSymName(GetType(ProcSym))) ;
-   WriteLn ;
+   CheckOptFunction - checks to see whether the optional return value
+                      has been set before and if it differs it will
+                      generate an error message.  It will set the
+                      new value to isopt.
 *)
-   PushT(ProcSym)
-END BuildOptFunction ;
+
+PROCEDURE CheckOptFunction (tok: CARDINAL; sym: CARDINAL; kind: ProcedureKind;
+                            isopt: BOOLEAN) ;
+VAR
+   other: ProcedureKind ;
+BEGIN
+   IF GetType (sym) # NulSym
+   THEN
+      (* Procedure sym has been declared as a function.  *)
+      FOR other := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+         IF (kind # other) AND GetProcedureParametersDefined (sym, other)
+         THEN
+            IF IsReturnOptional (sym, kind) AND (NOT isopt)
+            THEN
+               MetaErrorT1 (tok, 'procedure {%1Ea} is not declared with an optional return type here', sym) ;
+               MetaErrorT1 (GetReturnTypeTok (sym, kind),
+                            'previously procedure {%1Ea} was declared with an optional return type', sym)
+            ELSIF (NOT IsReturnOptional (sym, kind)) AND isopt
+            THEN
+               MetaErrorT1 (tok, 'procedure {%1Ea} is declared with an optional return type here', sym) ;
+               MetaErrorT1 (GetReturnTypeTok (sym, kind),
+                            'previously procedure {%1Ea} was declared without an optional return type', sym)
+            END
+         END
+      END
+   END ;
+   SetReturnOptional (sym, kind, isopt)
+END CheckOptFunction ;
 
 
 (*
    BuildNoReturnAttribute - provide an interface to the symbol table module.
 *)
 
-PROCEDURE BuildNoReturnAttribute (procedureSym: CARDINAL) ;
+PROCEDURE BuildNoReturnAttribute ;
+VAR
+   kind   : ProcedureKind ;
+   ProcSym,
+   tok    : CARDINAL ;
 BEGIN
-   Assert (IsProcedure (procedureSym)) ;
-   PutProcedureNoReturn (procedureSym, TRUE)
+   PopTtok (ProcSym, tok) ;
+   PushTtok (ProcSym, tok) ;
+   kind := GetProcedureKind (ProcSym, tok) ;
+   Assert (IsProcedure (ProcSym)) ;
+   PutProcedureNoReturn (ProcSym, kind, TRUE)
 END BuildNoReturnAttribute ;
 
 
@@ -2268,17 +2280,41 @@ END BuildNoReturnAttribute ;
 *)
 
 PROCEDURE CheckProcedure ;
+BEGIN
+   CheckProcedureReturn (NulSym, UnknownTokenNo)
+END CheckProcedure ;
+
+
+
+PROCEDURE CheckProcedureReturn (RetType: CARDINAL; typetok: CARDINAL) ;
 VAR
-   ProcSym,
-   tok    : CARDINAL ;
+   curkind,
+   kind       : ProcedureKind ;
+   tok        : CARDINAL ;
+   PrevRetType,
+   ProcSym    : CARDINAL ;
 BEGIN
    PopTtok (ProcSym, tok) ;
    PushTtok (ProcSym, tok) ;
-   IF GetType (ProcSym) # NulSym
+   Annotate ("%1s(%1d)||procedure start symbol") ;
+   IF IsProcedure (ProcSym)
    THEN
-      ReturnTypeMismatch (tok, ProcSym, NulSym)
+      curkind := GetProcedureKind (ProcSym, tok) ;
+      (* Check against any previously declared kinds.  *)
+      FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+         IF (kind # curkind) AND GetProcedureParametersDefined (ProcSym, kind)
+         THEN
+            PrevRetType := GetType (ProcSym) ;
+            IF PrevRetType # RetType
+            THEN
+               ReturnTypeMismatch (tok, ProcSym, RetType, typetok,
+                                   curkind, kind, PrevRetType)
+            END
+         END
+      END ;
+      PutFunction (tok, ProcSym, curkind, RetType)
    END
-END CheckProcedure ;
+END CheckProcedureReturn ;
 
 
 (*
diff --git a/gcc/m2/gm2-compiler/P3SymBuild.mod b/gcc/m2/gm2-compiler/P3SymBuild.mod
index 1bebcf066ce..b03f439a5ea 100644
--- a/gcc/m2/gm2-compiler/P3SymBuild.mod
+++ b/gcc/m2/gm2-compiler/P3SymBuild.mod
@@ -29,7 +29,7 @@ FROM M2Debug IMPORT Assert, WriteDebug ;
 FROM M2Error IMPORT WriteFormat0, WriteFormat1, WriteFormat2, FlushErrors, InternalError ;
 FROM M2LexBuf IMPORT GetTokenNo ;
 
-FROM SymbolTable IMPORT NulSym, ModeOfAddr,
+FROM SymbolTable IMPORT NulSym, ModeOfAddr, ProcedureKind,
                         StartScope, EndScope, GetScope, GetCurrentScope,
                         GetModuleScope,
                         SetCurrentModule, GetCurrentModule, SetFileModule,
@@ -45,7 +45,7 @@ FROM SymbolTable IMPORT NulSym, ModeOfAddr,
                         IsConst, IsConstructor, PutConst, PutConstructor,
                         PopValue, PushValue,
                         MakeTemporary, PutVar,
-                        PutSubrange,
+                        PutSubrange, GetProcedureKind,
                         GetSymName ;
 
 FROM M2Batch IMPORT MakeDefinitionSource,
@@ -692,10 +692,15 @@ END BuildVarAtAddress ;
 
 PROCEDURE BuildOptArgInitializer ;
 VAR
-   const: CARDINAL ;
+   tok    : CARDINAL ;
+   const,
+   ProcSym: CARDINAL ;
 BEGIN
-   PopT(const) ;
-   PutOptArgInit(GetCurrentScope(), const)
+   PopT (const) ;
+   PopTtok (ProcSym, tok) ;
+   Assert (IsProcedure (ProcSym)) ;
+   PushTtok (ProcSym, tok) ;
+   PutOptArgInit (GetCurrentScope (), const)
 END BuildOptArgInitializer ;
 
 
diff --git a/gcc/m2/gm2-compiler/PCSymBuild.mod b/gcc/m2/gm2-compiler/PCSymBuild.mod
index 498a0444325..f7d0ff3ecd9 100644
--- a/gcc/m2/gm2-compiler/PCSymBuild.mod
+++ b/gcc/m2/gm2-compiler/PCSymBuild.mod
@@ -52,7 +52,7 @@ FROM M2Reserved IMPORT PlusTok, MinusTok, TimesTok, DivTok, ModTok,
                        LessTok, GreaterTok, HashTok, LessGreaterTok,
                        InTok, NotTok ;
 
-FROM SymbolTable IMPORT NulSym, ModeOfAddr,
+FROM SymbolTable IMPORT NulSym, ModeOfAddr, ProcedureKind,
                         StartScope, EndScope, GetScope, GetCurrentScope,
                         GetModuleScope,
                         SetCurrentModule, GetCurrentModule, SetFileModule,
@@ -73,7 +73,7 @@ FROM SymbolTable IMPORT NulSym, ModeOfAddr,
                         CheckAnonymous,
                         IsProcedureBuiltin,
                         MakeProcType,
-                        NoOfParam,
+                        NoOfParamAny,
                         GetParam,
                         IsParameterVar, PutProcTypeParam,
                         PutProcTypeVarParam, IsParameterUnbounded,
@@ -1163,7 +1163,7 @@ BEGIN
       tok := GetTokenNo () ;
       t := MakeProcType (tok, CheckAnonymous (NulName)) ;
       i := 1 ;
-      n := NoOfParam(p) ;
+      n := NoOfParamAny (p) ;
       WHILE i<=n DO
          par := GetParam (p, i) ;
          IF IsParameterVar (par)
@@ -1176,7 +1176,7 @@ BEGIN
       END ;
       IF GetType (p) # NulSym
       THEN
-         PutFunction (t, GetType (p))
+         PutFunction (tok, t, ProperProcedure, GetType (p))
       END ;
       RETURN( t )
    ELSE
